/*
 * Copyright (c) 2007, 2008, 2009, 2010, 2011, 2012 David Berkman
 * 
 * This file is part of the SmallMind Code Project.
 * 
 * The SmallMind Code Project is free software, you can redistribute
 * it and/or modify it under the terms of GNU Affero General Public
 * License as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 * 
 * The SmallMind Code Project is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the the GNU Affero General Public
 * License, along with The SmallMind Code Project. If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * Additional permission under the GNU Affero GPL version 3 section 7
 * ------------------------------------------------------------------
 * If you modify this Program, or any covered work, by linking or
 * combining it with other code, such other code is not for that reason
 * alone subject to any of the requirements of the GNU Affero GPL
 * version 3.
 */
package org.smallmind.scribe.ink.log4j;

import org.apache.log4j.spi.LoggingEvent;
import org.smallmind.scribe.pen.Appender;
import org.smallmind.scribe.pen.ErrorHandler;
import org.smallmind.scribe.pen.MessageTranslator;
import org.smallmind.scribe.pen.Record;

public class Log4JErrorHandlerAdapter implements ErrorHandler {

  private org.apache.log4j.spi.ErrorHandler errorHandler;

  public Log4JErrorHandlerAdapter (org.apache.log4j.spi.ErrorHandler errorHandler) {

    this.errorHandler = errorHandler;
  }

  public org.apache.log4j.spi.ErrorHandler getNativeErrorHandler () {

    return errorHandler;
  }

  public void setBackupAppender (Appender appender) {

    errorHandler.setBackupAppender(new Log4JAppenderWrapper(appender));
  }

  public void process (Record record, Exception exception, String errorMessage, Object... args) {

    errorHandler.error(MessageTranslator.translateMessage(errorMessage, args), exception, 0, (LoggingEvent)record.getNativeLogEntry());
  }
}
